#include "conrt.h"
int		rtsock;
int kq; /*Our kqueue */
struct kevent *events;
int seq=0;

int main(){
    Rpointer	RouteNow,RouteTask;
    Ppointer	IndexNow,IndexTask,IndexDel,IndexCr;
    int		TaskN,NowN,CrN=0,DelN=0;
    int MaxRoute = MAXROUTE;
    int syslog_proc = SYSLOG_PROC;
    int num_events;
    int i,j,k;
    char *p1;
    int changed=1,doublenets=0,res;
	
    if (syslog_proc);
        openlog("conrt", LOG_CONS, LOG_USER); /*Opening log*/

    rtsock=Socket(AF_ROUTE,SOCK_RAW,0); /*This routing socket will be used all the time*/
    if ((kq=kqueue()) < 0)              /*That's the kq to be used all the time*/
        err_sys("Couldn't make kqueue");
    events = (struct kevent *) Calloc(1,sizeof(struct kevent));/*That's the event structure*/
    EV_SET(events,rtsock,EVFILT_READ,EV_ADD,0,0,NULL);
    Kevent(kq,events,1,NULL,0,0);
    /* Preparing and launching consuming of task */
    RouteTask = (Rpointer)Malloc(sizeof(Route)*MaxRoute);
    IndexTask = (Ppointer)Malloc(sizeof(Rpointer)*MaxRoute);
    if ((TaskN = addTask(&RouteTask,&IndexTask)) < 0) 
	err_quit("addTask failed. Terminating");
    for (j=1;j<TaskN;j++) {
	if (comparison_dst_mask(IndexTask+j-1,IndexTask+j) == 0) {
	    (*IndexTask[j]).not_allowed=1;
	    if (!doublenets) {
		err_msg("Double nets in task");
		doublenets=1;
	    }
	}
    }
    while (changed) {
	changed = 0;
	RouteNow = (Rpointer)Malloc(sizeof(Route)*MaxRoute);
	IndexNow = (Ppointer)Malloc(sizeof(Rpointer)*MaxRoute);
	
	if ((NowN = addNow(&RouteNow,&IndexNow)) <0)
	    err_quit("addNow failed. Terminating");
	IndexDel = (Ppointer)Malloc(sizeof(Rpointer)*NowN);
	IndexCr = (Ppointer)Malloc(sizeof(Rpointer)*TaskN);
	CrN=0;DelN=0;
	i=j=0;
	while (i<NowN && j<TaskN){
	    if ((*IndexTask[j]).not_allowed == 1) {
		j++;
		continue;
	    }
            res=(comparison(IndexNow+i,IndexTask+j));
	    switch (res) { 
		case 1: {
		    IndexCr[CrN++]=IndexTask[j];
//		    printf("Will be created\n");
		    j++;
		    changed=1;
		    break;
		}
		case 0: {
		    j++;i++;
//		    printf("Will be skipped\n");
		    break;
		}
		case -1: {
		    IndexDel[DelN++]=IndexNow[i];
//		    printf("Will be destroyed\n");
		    changed=1;
		    i++;
		    break;
		}
		default: {
	    	    err_quit("Abnormal Termination while comparing");
                }
	    }
	}
	if (j==TaskN) {
	    for (k=i;k<NowN;k++) {
		IndexDel[DelN++]=IndexNow[k];
		changed=1;
	    }
	}
	if (i==NowN) {
	    for (k=j;k<TaskN;k++) {
		if ((*IndexTask[k]).not_allowed == 1) {
                    k++;
		    continue;
                }
		IndexCr[CrN++]=IndexTask[k];
		changed=1;
	    }
	}
	for (i=0;i<DelN;i++)
	    send_op(IndexDel[i],RTM_DELETE); 
	for (i=0;i<CrN;i++)
	    send_op(IndexCr[i],RTM_ADD);
	free (IndexDel);
	free (IndexCr);
	free (RouteNow);
	free (IndexNow);
	if (changed)
	    err_msg("Configuration updated: deleted %i added %i",DelN,CrN);
  //  return 0;
	//changed=0;
    }
    err_msg("completed");
return 0;
}
