#include <sys/param.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <sys/sysctl.h>
#include <sys/wait.h>
#include <syslog.h>
#include <sys/types.h>
#include <sysexits.h>
#include <sys/event.h>

#include <net/if.h>
#include <net/if_dl.h>
#include <net/if_types.h>
#include <netinet/in.h>
#include <netinet/if_ether.h>
#include <net/route.h>

/* IP */
#include <arpa/inet.h>
#include <netdb.h>

#include <ifaddrs.h>
#include <ctype.h>
#include <err.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

typedef union	sockunion {
		struct	sockaddr sa;
		struct	sockaddr_in sin;
		struct	sockaddr_dl sdl;
		struct	sockaddr_inarp sinarp;
		struct  sockaddr_storage ss;
} Address;

typedef Address		*PAddress;

typedef struct Rnet	{Address	dst;
                         Address	gateway;
                         Address	netmask;
			 int		type;
			 int		not_allowed;
} Route;

typedef Route     	*Rpointer;
typedef Rpointer	*Ppointer;

typedef struct rt_msg{
	struct	rt_msghdr m_rtm;
	char	m_space[512];
} m_rtmsg;

#ifndef MAXROUTE
#define MAXROUTE 1000
#endif
#ifndef MAXLINE
#define MAXLINE 4096
#endif
#ifndef SYSLOG_PROC
#define SYSLOG_PROC 1
#endif
#ifndef ERROR_GET_SYSCTL
#define ERROR_GET_SYSCTL 20
#endif

#define ROUTE_INET 0
#define ROUTE_IFACE 1
#define ROUTE_ETH 2
#define ROUTE_LAST 3

#define ROUNDUP(a) ((a) > 0 ? (1 + (((a) - 1) | (sizeof(long) - 1))) : sizeof(long))
#define ADVANCE(x, n) (x += ROUNDUP((n)->sa_len))