#include "conrt.h"

int comparison(Ppointer p1, Ppointer p2);

int addNow(Rpointer *Now, Ppointer *Index){
    int mib[6];
    char *buf,*lim,*next,*cp;
    unsigned char *ptr;
    size_t needed=0;
    struct  rt_msghdr	*rtm;
    struct  sockaddr    *sa;
    struct  sockaddr_in *sin;
    struct  in_addr	in;
    int NowN=0;
    PAddress paddr_d,paddr_g,paddr_n;
    int MaxRoute = MAXROUTE;
    int addrs;
    int flags;
    int i;

    /* Retrieving Configuration */
    mib[0]=CTL_NET;
    mib[1]=PF_ROUTE;
    mib[2]=0;
    mib[3]=AF_INET;
    mib[4]=NET_RT_DUMP;
    mib[5]=0;

    if ((buf = (char *)Get_Sysctl(mib,6,&needed)) == NULL)
	err_quit("Failed to get information via sysctl()");
    lim=buf+needed;
    next=buf;
    for (next = buf; next < lim; next += rtm->rtm_msglen) {
    	rtm = (struct rt_msghdr *)next;
	flags=rtm->rtm_flags;
	addrs=rtm->rtm_addrs;
	paddr_d = &((*Now)[NowN].dst);
	paddr_g = &((*Now)[NowN].gateway);
	paddr_n = &((*Now)[NowN].netmask);
	bzero(paddr_d,sizeof(Address));
	bzero(paddr_g,sizeof(Address));
	bzero(paddr_n,sizeof(Address));
	/* Destination is always a sockaddr_in entry and must be present*/
	cp=(char *)(rtm+1);
	if (!(flags&RTF_STATIC))
	    /* Skip non-Static messages*/
	    continue;	
	if (addrs&RTA_DST) {
	        paddr_d->sin.sin_len=sizeof(struct sockaddr_in);
		paddr_d->sin.sin_family=AF_INET;
		sa = (struct sockaddr *)cp;
		sin = (struct sockaddr_in *)sa;
		if (sin->sin_len==0)
		    paddr_d->sin.sin_addr.s_addr=0;
		else {
		    in = sin->sin_addr;
		    paddr_d->sin.sin_addr.s_addr=in.s_addr;
		}
		ADVANCE(cp, sa);
	}
	else
	    continue;
	/* Gateway must also be present */
	if (addrs&RTA_GATEWAY) {
	    if ((rtm->rtm_flags & RTF_HOST) && (rtm->rtm_flags & RTF_LLINFO)){
	    /* This is the case of ROUTE_ETH */
		sa = (struct sockaddr *)cp;
	        bcopy(sa,&(paddr_g->sdl),sa->sa_len);
		ADVANCE(cp, sa);
		(*Now)[NowN].type=ROUTE_ETH;
	    }
	    else if (!(rtm->rtm_flags & RTF_GATEWAY)){
	    /* This is the case of ROUTE_IFACE (ROUTE_ETH already resolved) */
		sa = (struct sockaddr *)cp;
		bcopy(sa,&(paddr_g->sdl),sa->sa_len);
		ADVANCE(cp, sa);
		(*Now)[NowN].type=ROUTE_IFACE;
	    }
	    else if (rtm->rtm_flags & RTF_GATEWAY) {
		sa = (struct sockaddr *)cp;
		bcopy(sa,&(paddr_g->sin),sa->sa_len);
		ADVANCE(cp, sa);
		(*Now)[NowN].type=ROUTE_INET;
	    }
	    else {
		/*Shouldn't reach this*/
		err_msg("Strange route message arrived");
		continue;
	    }
	}
	if (addrs&RTA_NETMASK) {
	    paddr_n->sin.sin_len=sizeof(struct sockaddr_in);
	    paddr_n->sin.sin_family=0;
	    sa = (struct sockaddr *)cp;
	    sin = (struct sockaddr_in *)sa;
	    ptr = (unsigned char *)&(sin->sin_addr);
	    if (sin->sin_len==0)
		paddr_n->sin.sin_addr.s_addr=0;
	    else if (sin->sin_len==5) 
		paddr_n->sin.sin_addr.s_addr=*ptr;
	    else if (sin->sin_len==6)
		paddr_n->sin.sin_addr.s_addr=*(ptr+1)*256+*ptr;
	    else if (sin->sin_len==7)
		paddr_n->sin.sin_addr.s_addr=(*(ptr+2)*256+*(ptr+1))*256+*ptr;
	    else if (sin->sin_len==8)
		paddr_n->sin.sin_addr.s_addr=((*(ptr+3)*256+*(ptr+2))*256+*(ptr+1))*256+*ptr;
	    else {
		err_msg("Strange masklen");
		continue;
	    }
	    ADVANCE(cp, sa);
	}
	else if (rtm->rtm_flags & RTF_HOST) {
	    paddr_n->sin.sin_addr.s_addr=0xffffffff;
	    paddr_n->sin.sin_family=0;
	    paddr_n->sin.sin_len=sizeof(struct sockaddr_in);
	}
	else {
	    err_msg("Strange route message arrived");
	    continue;
	}
	if (addrs&RTA_GENMASK) {
	    ADVANCE(cp, sa);
	}
	if ((*Now)[NowN].type==ROUTE_IFACE) {
	    sa = (struct sockaddr *)cp;
	    bcopy(sa,&(paddr_g->sdl),sa->sa_len);
	}
	(*Now)[NowN].not_allowed=0;
	NowN++;
        if (NowN>MaxRoute-1) {
                MaxRoute=MaxRoute*2;
                (*Now)=(Rpointer)Reallocf((*Now),sizeof(Route)*MaxRoute);
	}

    }
    (*Now) = (Rpointer)Reallocf((*Now),sizeof(Route)*NowN);
    (*Index) = (Ppointer)Reallocf((*Index),sizeof(Rpointer)*NowN);
    for (i=0;i<NowN;i++) {
        (*Index)[i]=&((*Now)[i]);
    }
    qsort((void **) (*Index), NowN, sizeof(Rpointer), (int (*)(const void *, const void *))comparison);
    return NowN;
}