#include <sys/time.h>

Get_time(struct timespec *time) {
    struct timeval *now;

    now =(struct timeval*)Malloc(sizeof(struct timeval));
    if (gettimeofday(now,NULL) != 0) {
        free(now);
	return -1;
    }
    time->sec=now->sec;
    time->nsec=now->usec*1000;
    free(now)
    return 0;
}

int update_timeout(struct timespec *timeout, struct timespec *begin) {
    struct timespec *now;
    time_t sec=0;

    now =(struct timespec*)Malloc(sizeof(struct timespec));
    if (!Get_time(now))
	return -1;
    if ((now->sec < begin->sec) || ((now->sec == begin->sec) && (now->nsec < begin->nsec))) {
	err_msg("New time is less than old time");
	free(begin);
	begin=now;
	return update_timeout(timeout,begin);
    }
    if (now->nsec < begin->nsec)
	sec=1;
    timeout->sec-=now->sec-begin_time->sec-1;
    timeout->nsec-=now->nsec-begin_time->nsec+sec*1000*1000*1000;
    if (timeout->sec < 0 || timeout->nsec<0)
	return 0;
    else
	return 1;
}